 precision mediump float;

 varying mediump vec2 textureCoordinate;

 uniform sampler2D inputImageTexture;
 uniform sampler2D inputImageTexture2;

 mediump float saturation = 0.9;

 uniform float p1;

 // Values from "Graphics Shaders: Theory and Practice" by Bailey and Cunningham
 const mediump vec3 luminanceWeighting = vec3(0.2125, 0.7154, 0.0721);

 void main()
 {
     vec4 textureColor = texture2D(inputImageTexture, textureCoordinate);
     float luminance = dot(textureColor.rgb, luminanceWeighting);
     vec3 greyScaleColor = vec3(luminance);

     vec4 desaturationColor = vec4(mix(greyScaleColor, textureColor.rgb, saturation), textureColor.w);

     vec4 mappedColor = desaturationColor;
     mappedColor.r = texture2D(inputImageTexture2, vec2(desaturationColor.r, 0.0)).r;
     mappedColor.g = texture2D(inputImageTexture2, vec2(desaturationColor.g, 0.0)).g;
     mappedColor.b = texture2D(inputImageTexture2, vec2(desaturationColor.b, 0.0)).b;

     vec4 result;
     result.rgb = mix(textureColor.rgb, mappedColor.rgb, p1);
     result.a = 1.0;

     gl_FragColor = result;
 }