precision highp float;

  varying highp vec2 textureCoordinate;

  uniform sampler2D inputImageTexture;
  uniform sampler2D inputImageTexture2;

  uniform float p1;

 void main()
 {
     // sharp
     vec4 textureColor = texture2D(inputImageTexture, textureCoordinate);

     // curve tone
     vec4 curveColor = textureColor;
     curveColor.r = texture2D(inputImageTexture2, vec2(textureColor.r, 0.0)).r;
     curveColor.g = texture2D(inputImageTexture2, vec2(textureColor.g, 0.0)).g;
     curveColor.b = texture2D(inputImageTexture2, vec2(textureColor.b, 0.0)).b;

     // blend
     vec4 mulColor = curveColor;
     mulColor.rgb = curveColor.rgb*vec3(1.0, 0.5725, 0.0039);
     mulColor.rgb = mix(curveColor.rgb, mulColor.rgb, 0.1);

     vec4 result = textureColor;
     result.rgb = mix(textureColor.rgb, mulColor.rgb, p1);

     gl_FragColor = result;
 }