precision mediump float;

 varying vec2 textureCoordinate;
 varying vec2 textureCoordinate2;
 varying vec2 textureCoordinate3;

 uniform sampler2D inputImageTexture;
 uniform sampler2D inputImageTexture2;
 uniform sampler2D inputImageTexture3;
 uniform sampler2D inputImageTexture4;

 vec3 gradient_map(vec3 color)
 {
     vec3 curveColor;
     curveColor.r = texture2D(inputImageTexture4, vec2(color.r, 0.0)).r;
     curveColor.g = texture2D(inputImageTexture4, vec2(color.g, 0.0)).g;
     curveColor.b = texture2D(inputImageTexture4, vec2(color.b, 0.0)).b;

     return curveColor;
 }

 void main()
 {
     vec4 textureColor = texture2D(inputImageTexture, textureCoordinate);

     // gradient
     textureColor.rgb = gradient_map(textureColor.rgb);

     vec4 textureColor2 = texture2D(inputImageTexture2, vec2(textureCoordinate2.x,textureCoordinate2.y + 0.05));
     textureColor = vec4(mix(textureColor.rgb, textureColor2.rgb, textureColor2.a), textureColor.a);

     vec4 textureColor3 = texture2D(inputImageTexture3, textureCoordinate3);
     gl_FragColor = vec4(mix(textureColor.rgb, textureColor3.rgb, textureColor3.a), textureColor.a);

 }
