precision highp float;

 varying highp vec2 textureCoordinate;

 uniform sampler2D inputImageTexture;
 uniform sampler2D inputImageTexture2; //R,G,B mapping

uniform float p1;

 void main()
 {

     vec4 texel = texture2D(inputImageTexture, textureCoordinate);

     vec4 mapped;
     mapped.r = texture2D(inputImageTexture2, vec2(texel.r, 0.0)).r;
     mapped.g = texture2D(inputImageTexture2, vec2(texel.g, 0.0)).g;
     mapped.b = texture2D(inputImageTexture2, vec2(texel.b, 0.0)).b;
     mapped.a = 1.0;

     vec4 result;
     result.rgb = mix(texel.rgb, mapped.rgb, p1);
     result.a = 1.0;

     gl_FragColor = result;
 }